"""autogenerated by genmsg_py from SpawnModelRequest.msg. Do not edit."""
import roslib.message
import struct

import gazebo_plugins.msg
import geometry_msgs.msg

class SpawnModelRequest(roslib.message.Message):
  _md5sum = "8915810c16a568ad2934526b89348967"
  _type = "gazebo_plugins/SpawnModelRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """gazebo_plugins/GazeboModel model

================================================================================
MSG: gazebo_plugins/GazeboModel
# This is a message that hold the data necessary to spawn a model in Gazebo
# this message is used by SpawnModel service calls to RosFactory plugin.

string model_name                        # name of the model to be spawned in Gazebo
string robot_model                       # contains either URDF or Gazebo XML robot model
uint32 xml_type                          # specifies what the content of robot_model is
string robot_namespace                   # ros namespace for all the ros interface of the model
geometry_msgs/Pose initial_pose          # initial pose in the gazebo world frame
uint32 disable_urdf_joint_limits = 0     # special flag to disable URDF joint limits
uint32 URDF                  = 0         # enum: robot_model contains XML string for an URDF model
uint32 GAZEBO_XML            = 1         # enum: robot_model contains XML string for an URDF model
uint32 URDF_PARAM_NAME       = 2         # enum: robot_model contains parameter name containing URDF XML
uint32 GAZEBO_XML_PARAM_NAME = 3         # enum: robot_model contains parameter name containing Gazebo Model XML
uint32 URDF_FILE_NAME        = 4         # enum: robot_model contains file name containing URDF XML
uint32 GAZEBO_XML_FILE_NAME  = 5         # enum: robot_model contains file name containing Gazebo Model XML


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['model']
  _slot_types = ['gazebo_plugins/GazeboModel']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       model
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SpawnModelRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
    else:
      self.model = gazebo_plugins.msg.GazeboModel()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.model.model_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.model.robot_model
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.model.xml_type))
      _x = self.model.robot_namespace
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.model.initial_pose.position.x, _x.model.initial_pose.position.y, _x.model.initial_pose.position.z, _x.model.initial_pose.orientation.x, _x.model.initial_pose.orientation.y, _x.model.initial_pose.orientation.z, _x.model.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.model_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.robot_model = str[start:end]
      start = end
      end += 4
      (self.model.xml_type,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.robot_namespace = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.model.initial_pose.position.x, _x.model.initial_pose.position.y, _x.model.initial_pose.position.z, _x.model.initial_pose.orientation.x, _x.model.initial_pose.orientation.y, _x.model.initial_pose.orientation.z, _x.model.initial_pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.model.model_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.model.robot_model
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_I.pack(self.model.xml_type))
      _x = self.model.robot_namespace
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.model.initial_pose.position.x, _x.model.initial_pose.position.y, _x.model.initial_pose.position.z, _x.model.initial_pose.orientation.x, _x.model.initial_pose.orientation.y, _x.model.initial_pose.orientation.z, _x.model.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.model_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.robot_model = str[start:end]
      start = end
      end += 4
      (self.model.xml_type,) = _struct_I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model.robot_namespace = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.model.initial_pose.position.x, _x.model.initial_pose.position.y, _x.model.initial_pose.position.z, _x.model.initial_pose.orientation.x, _x.model.initial_pose.orientation.y, _x.model.initial_pose.orientation.z, _x.model.initial_pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7d = struct.Struct("<7d")
"""autogenerated by genmsg_py from SpawnModelResponse.msg. Do not edit."""
import roslib.message
import struct


class SpawnModelResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "gazebo_plugins/SpawnModelResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       success,status_message
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(SpawnModelResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      buff.write(_struct_B.pack(self.success))
      _x = self.status_message
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _struct_B.unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.status_message = str[start:end]
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
class SpawnModel(roslib.message.ServiceDefinition):
  _type          = 'gazebo_plugins/SpawnModel'
  _md5sum = 'ce64f81e9bc82e2fce98de7d4eea3e13'
  _request_class  = SpawnModelRequest
  _response_class = SpawnModelResponse
